#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local;
use LWP 5.64;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES


##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "add_listing") {&add_listing;}
if ($q->param('fct') eq "add_listing_final") {&add_listing_final;}
if ($q->param('fct') eq "add_listing_m") {&add_listing_m;}
if ($q->param('fct') eq "add_listing_m_final") {&add_listing_m_final;}

#### GET CONFIGURATION ########################################################


sub add_listing_m_final
{

if (($q->param('title1') eq "") and ($q->param('title2') eq "") and ($q->param('title3') eq "") and ($q->param('title4') eq "") and ($q->param('title5') eq ""))
	{
	acs::problem_popup("No titles supplied. A link should at least have a title before it can be added.");
	}

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


### CHECK FOR DUPLICATES
if ($q->param('duplicates') eq "Y")
{

if (($q->param('title1') ne "") and ($q->param('url1') ne ""))
	{
	$url1 = $q->param('url1');
	$url1 =~ s/'/\\'/g;
	$dsql = $dsql . " (A.url = '$url1') OR";
	
	if (substr($url1, length($url1) - 1, 1) eq "/")
		{
		$url1 = substr($url1, 0, length($url1) - 1);
		$dsql = $dsql . " (A.url = '$url1') OR";
		}
		else
		{
		$dsql = $dsql . " (A.url = '$url1/') OR";
		}

	}

if (($q->param('title2') ne "") and ($q->param('url2') ne ""))
	{
	$url2 = $q->param('url2');
	$url2 =~ s/'/\\'/g;
	$dsql = $dsql . " (A.url = '$url2') OR";

	if (substr($url2, length($url2) - 1, 1) eq "/")
		{
		$url2 = substr($url2, 0, length($url2) - 1);
		$dsql = $dsql . " (A.url = '$url2') OR";
		}
		else
		{
		$dsql = $dsql . " (A.url = '$url2/') OR";
		}
	}


if (($q->param('title3') ne "") and ($q->param('url3') ne ""))
	{
	$url3 = $q->param('url3');
	$url3 =~ s/'/\\'/g;
	$dsql = $dsql . " (A.url = '$url3') OR ";

	if (substr($url3, length($url3) - 1, 1) eq "/")
		{
		$url3 = substr($url3, 0, length($url3) - 1);
		$dsql = $dsql . " (A.url = '$url3') OR";
		}
		else
		{
		$dsql = $dsql . " (A.url = '$url3/') OR";
		}
	}


if (($q->param('title4') ne "") and ($q->param('url4') ne ""))
	{
	$url4 = $q->param('url4');
	$url4 =~ s/'/\\'/g;
	$dsql = $dsql . " (A.url = '$url4') OR";
	
	if (substr($url4, length($url4) - 1, 1) eq "/")
		{
		$url4 = substr($url4, 0, length($url4) - 1);
		$dsql = $dsql . " (A.url = '$url4') OR";
		}
		else
		{
		$dsql = $dsql . " (A.url = '$url4/') OR";
		}
	
	}

if (($q->param('title5') ne "") and ($q->param('url5') ne ""))
	{
	$url5 = $q->param('url5');
	$url5 =~ s/'/\\'/g;
	$dsql = $dsql . " (A.url = '$url5') OR";
	
		if (substr($url5, length($url5) - 1, 1) eq "/")
			{
			$url5 = substr($url5, 0, length($url5) - 1);
			$dsql = $dsql . " (A.url = '$url5') OR";
			}
			else
			{
			$dsql = $dsql . " (A.url = '$url5/') OR";
			}
	}

$dsql = substr($dsql, 0, length($dsql) - 2);

$sql = "SELECT A.title, A.description, A.url, B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16
							FROM links AS A, dirs AS B 
							WHERE (B.cid = A.cid)
							AND ($dsql)";

#print "==> $sql <br>";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$cats = "";
	for ($ms = 3; $ms < 20; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		}
	$duplicates_lnks = $duplicates_lnks . "<strong><a href=\"$row[2]\">$row[0]</a></strong><br>$row[1]<br><strong>$row[2]</strong><br><b>Category:</b> /$cats<Br><br><br>";
	}


if ($duplicates_lnks ne "")
	{
	acs::problem_popup("You have indicated that you would like to check for duplicate(s). The following duplicate(s) has been found: <br><br> <font face=\"Verdana\" size=\"1\">$duplicates_lnks</font> ");
	}


} ### END OF DUPLICATE CHECKING



### CHECK PREMIUM EXPIRY DATES AND NORMAL DATES
for ($ms = 1; $ms < 6; $ms++) 
{

$premium_expiry = "subs_expire" . $ms;
$premium_expiry = $q->param($premium_expiry);

if ($premium_expiry ne "")
	{
	$premium_expiry =~ s/ //g;
	($pyear,$pmonth,$pday) = split (/\//, $premium_expiry);
	$pmonth = $pmonth - 1;
	
	eval { $time = timelocal(0,0,0, $pday,$pmonth,$pyear);
 		  }; #warn $@ if $@;
	 	if ($@ ne "") 
 			{
			$lnkn = $ms + 1; #<br></b>Reason:</b> $@
 			acs::problem_popup("The date ($premium_expiry) that you specified for the item/link number $ms is not a valid date. <br></b>Reason:</b> $@"); 
 			}

 	$pexp[$ms - 1] = $time;
	}

### NORMAL DATES

$urldate = "urldate" . $ms;
$urldate = $q->param($urldate);

if ($urldate ne "")
	{
	$urldate =~ s/ //g;
	($pyear,$pmonth,$pday) = split (/\//, $urldate);
	$pmonth = $pmonth - 1;
	
	eval { $time = timelocal(0,0,0, $pday,$pmonth,$pyear);
 		  }; #warn $@ if $@;
	 	if ($@ ne "") 
 			{
			$lnkn = $ms + 1; #<br></b>Reason:</b> $@
 			acs::problem_popup("The date ($urldate) that you specified for the item/link number $ms is not a valid date. <br></b>Reason:</b> $@"); 
 			}

 	$pexp2[$ms - 1] = $time;
	}


}




#### GET KEYS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;



### CREATE UPLOAD DIR IF NOT EXISTS
$upload_dir = "$web_dir/imagefiles";

if ((-e $upload_dir) < 1)
	{
	mkdir ($upload_dir, $default_permissions);
	chmod($default_permissions, $upload_dir);
	}



#### DO SQL INSERT/COPY


for ($ms = 1; $ms < 6; $ms++) 
{
$title = "title" . $ms;
$title = $q->param($title);
$title =~ s/'/\\'/g;

if ($title ne "")
	{
	$description = "description" . $ms;
	$description = $q->param($description);
	$description =~ s/'/\\'/g;

	$keywords = "keywords" . $ms;
	$keywords = $q->param($keywords);
	$keywords =~ s/'/\\'/g;

	$url = "url" . $ms;
	$url = $q->param($url);
	$url =~ s/'/\\'/g;

	$image = "image" . $ms;
	$image = $q->param($image);
	$image =~ s/'/\\'/g;

	$imagelinked = "imagelinked" . $ms;
	$imagelinked = $q->param($imagelinked);
	$imagelinked =~ s/'/\\'/g;

	$name = "name" . $ms;
	$name = $q->param($name);	
	$name =~ s/'/\\'/g;

	$email = "email" . $ms;
	$email = $q->param($email);	
	$email =~ s/'/\\'/g;

	$rating = "rating" . $ms;
	$rating = $q->param($rating);	

	$votes = "votes" . $ms;
	$votes = $q->param($votes);	

	$hits = "hits" . $ms;
	$hits = $q->param($hits);	

	$premium = "premium" . $ms;
	$premium = $q->param($premium);	

	$modified = "modified" . $ms;
	$modified = $q->param($modified);	

	$newsubm = "newsubm" . $ms;
	$newsubm = $q->param($newsubm);	

	$lnkpassword = "password" . $ms;
	$lnkpassword = $q->param($lnkpassword);	
	$lnkpassword =~ s/'/\\'/g;

	$subs_expire = "subs_expire" . $ms;
	if ($q->param($subs_expire) ne "")
		{
		$subs_expire = $pexp[$ms -1];
		}
	

	$urldate5 = "urldate" . $ms;
	if ($q->param($urldate5) ne "")
		{
		$urldate = $pexp2[$ms-1];
		}
		else
		{
		$urldate = time();
		}
	




#### GET KEY VALUES
$extrak_values = ""; $found_upload = "";
my (@files_to_upload);

if ($knr > 0)
	{
	$kcount = 0;
	foreach $k_item (@akeys)
		{
		($k_keyname, $k_visible, $k_size, $k_searched, $k_description, $na, $imgk, $nmbr) = split (/\t/, $k_item);

		$realkname = $k_keyname . "_cust";
		$fillbname = $k_keyname . "$ms";

			if ($nmbr eq "Upload")
				{
				if ($q->param($fillbname) ne "")
					{
					push (@files_to_upload, $k_keyname . "::o::" . $ms);
					$found_upload = "true";
					
					my @fext = split (/\./, $q->param($fillbname)); $fnr = @fext; $fextension = $fext[$fnr -1];
					
					
					$extrak_values = $extrak_values . ", $realkname = '" . $fextension . "'";
					}
					else
					{
					$extrak_values = $extrak_values . ", $realkname = ''";
					}
				
				}
				else
				{
				$extrak_values = $extrak_values . ", $realkname = '" . $q->param($fillbname) . "'";
				}
		$kcount++;
		}
	}



$insert_sql = "INSERT INTO links SET  cid = '$cid',
											title = '$title',
											description = '$description',
											keywords = '$keywords',
											url = '$url',
											image = '$image',
											imagelinked = '$imagelinked',
											name = '$name',
											email = '$email',
											rating = '$rating',
											votes = '$votes',
											hits = '$hits',

											premium = '$premium',
											modified = '$modified',
											newsubm = '$newsubm',
											userid = '$userid',
											urldate = '$urldate',
											lnkpassword = '$lnkpassword',
											subs_expire = '$subs_expire'
											$extrak_values
											";


	$sth = $dbh->prepare($insert_sql);
   $sth->execute;
	$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror";}
   

   
   ### IF WE NEED TO UPLOAD EXTRA FIELD FILES

   if ($found_upload eq "true")
   	{
   	
   	### GET LAST INSERT ID
   	
		$sth = $dbh->prepare("SELECT lnkid FROM links WHERE lnkid = LAST_INSERT_ID()");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		while ( @row = $sth->fetchrow() ) {$last_link_id = $row[0]; }   

			if ((-e "$web_dir/imagefiles/$last_link_id") < 1)
				{
				mkdir ("$web_dir/imagefiles/$last_link_id", $default_permissions);
				chmod ($default_permissions, "$web_dir/imagefiles/$last_link_id");
				}

		### UPLOAD EXTRA FIELD KEY FILES
		
   	foreach $uitem (@files_to_upload)
   		{
   		($u_keyname, $u_ms) = split (/::o::/, $uitem);
   		
			$fhname = $u_keyname . $u_ms;
			
			my @fext = split (/\./, $q->param($fhname)); $fnr = @fext; $fextension = $fext[$fnr -1];
			
			$ufname = "$web_dir/imagefiles/$last_link_id/" . $u_keyname . "." . $fextension;
			
  			$upload_filehandle = $q->param($fhname);
  			
				open UPLOADFILE, ">$ufname"; 
					binmode UPLOADFILE; 
					  while ( <$upload_filehandle> )
							 {
						    print UPLOADFILE;
							 } 	
				close UPLOADFILE;
   		}
   	
   	}
   
   
   
   
   $number_of_new_links++;
	}

}



	



### UPLOAD STANDARD IMAGE IF ANY

for ($ms = 1; $ms < 6; $ms++) 
{

$imgname = "image" . $ms;

if ($q->param($imgname) ne "")
	{
	$upload_filename = $q->param($imgname); 
	$upload_filename =~ s/.*[\/\\](.*)/$1/;
		
	my @fext = split (/\./, $upload_filename);
	$fnr = @fext;
	$fextension = $fext[$fnr -1];
		
	#### GET LAST INSERTED LINK-ID FROM DB
	
		$title = "title" . $ms;
		$title = $q->param($title);
		$title =~ s/'/\\'/g;
	
		$url = "url" . $ms;
		$url = $q->param($url);
		$url =~ s/'/\\'/g;
	
	$sth = $dbh->prepare("SELECT lnkid FROM links WHERE (title = '$title') AND (cid = '$cid') AND (url = '$url')");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	while ( @row = $sth->fetchrow() ) {$last_insert_id = $row[0]; } 
		
	$ufname = $last_insert_id . "." . $fextension;
	$ufname = "$upload_dir/$ufname";
		
	### DO UPLOAD
	$upload_filehandle = $q->param($imgname);
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;
		
	### UPDATE DB TO INDICATE THAT THE LINK HAS AN IMAGE
	$sth = $dbh->prepare("UPDATE links SET image = '$fextension' WHERE lnkid = '$last_insert_id'");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}	
	
	}
}



$sth->finish;
$dbh->disconnect;


### UPDATE LINK NUMBERS
acs::update_numbers ("+", $number_of_new_links, $rid);


$hbox = acs::get_heading_box("$web_url/add.gif", "New Listing(s) Added", qq[<ul>
  <li><a
    href="$admin_url/admin4.cgi?fct=add_listing_m&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid">Click
    here to add more links.</a></li>
  <li><a href="javascript:onClick=window.close()">Click Here to Close</a> this window.</li>
  <li>Click your browser's refresh button in the parent window (browser window from where this
    one was opened) to see the new listings you have just added.</li>
</ul>]);


print <<END_OF_ADDED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox

</body>
</html>

END_OF_ADDED

}







sub add_listing_m
{



$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');

$location = acs::get_location_string ($ct);

##########

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

if ($knr > 0)
	{
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $notext, $imagek, $fieldtype) = split (/\t/, $k_item);

	for ($ms = 1; $ms < 6; $ms++) 
		{
		$nrkeyname = $keyname . $ms;
		
			if ($fieldtype eq "Upload")
				{
					$extra_key_fields[$ms] = $extra_key_fields[$ms] . qq[
					<tr>
					    <td width="29%" valign="top" bgcolor="#FFFFFF"><font color="#804040"><span
					    class="normaltext"> <strong>$description:</strong></span></font></td>
					    <td width="72%" bgcolor="#FFFFFF"><input type="file" name="$nrkeyname" size="45"
					    style="width:100%"></td>
  					</tr>
		 	      ];

				}
			elsif ($size < 256)
				{
				if ($imagek eq "Yes"){$fcolor = "#008040"; } else {$fcolor = "#8080C0";  }
				
$extra_key_fields[$ms] = $extra_key_fields[$ms] . <<END_OF_EXKF;
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF"><strong><span class="normaltext"> $icong <font color="$fcolor">$description:</font></span></strong></td>
    <td width="72%" bgcolor="#FFFFFF"><input type="text" name="$nrkeyname" size="40"  style="width:100%"></td>
  </tr>
END_OF_EXKF
				}
				else
				{
				if ($imagek eq "Yes"){$fcolor = "#008040"; } else {$fcolor = "#8080C0"; }
				
$extra_key_fields[$ms] = $extra_key_fields[$ms] . <<END_OF_EXKF2;
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF"><strong> <span class="normaltext"><font color="$fcolor">$description:</font></span></strong></td>
    <td width="72%" bgcolor="#FFFFFF"><textarea rows="6" name="$nrkeyname" cols="40" style="width:100%"></textarea></td>
  </tr>
END_OF_EXKF2
				}
		}
	 }
	}


$hbox = acs::get_heading_box("$web_url/add.gif", "Add Multiple Links To:", qq[$location]);




$gsettings = new_gsettings acs; 



if ($gsettings->{addurl_reg_system} ne "Yes")
	{
	$modpass1 = qq[
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Password:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="password1" size="40" ><br>      </td>
    </tr>
     ];
     
	$modpass2 = qq[
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Password:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="password2" size="40" ></td>
    </tr>
     ];

	$modpass3 = qq[
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Password:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="password3" size="40" ></td>
    </tr>
     ];


	$modpass4 = qq[
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Password:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="password4" size="40" ></td>
    </tr>
     ];

	$modpass5 = qq[
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Password:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="password5" size="40" ></td>
    </tr>
     ];

     
	}




print <<END_OF_ADDM;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
<script LANGUAGE="JavaScript">
<!-- Hide
	function popup(loc)
   {
	TheNewWin = window.open(loc,'help','height=150,width=200,toolbar=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no');
   }
// End Hide -->
</script>
</head>
<body>



<form method="POST" action="$admin_url/admin4.cgi" ENCTYPE="multipart/form-data" name="addform">
  

$hbox

  <div align="center">
    <center>
  
<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
    <tr>
      <td height="30" colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>LINK 1</strong></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Title:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="title1" size="60" style="width:100%"><br>
      Max 255 Chars</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="description1" cols="59"
      style="width:100%"></textarea><br>
      Max 255 Characters</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="keywords1" size="60" style="width:100%"><br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url1" size="60" value="http://" style="width:90%">
       <input type="submit" value="Fetch" name="metainfo1" 
        onClick="popup('$admin_url/admin72.cgi?metpos=1&fct=meta1&url=' + url1.value);return false;"><br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="name1" size="43" style="width:100%"><br>
      Max 100 Characters - The name of the
      submitter or company name</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email
      Address:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="email1" size="60" style="width:100%"><br>
      Max 255 Characters - You can use this
      email address for mailing list purposes</td>
    </tr>
$modpass1
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="urldate1" size="13" >(YYYY/MM/DD)<br>      </td>
    </tr>
    
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Rating:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><select name="rating1"
      size="1">
        <option value="0">Unrated</option>
        <option value="10">10</option>
        <option value="9">9</option>
        <option value="8">8</option>
        <option value="7">7</option>
        <option value="6">6</option>
        <option value="5">5</option>
        <option value="4">4</option>
        <option value="3">3</option>
        <option value="2">2</option>
        <option value="1">1</option>
      </select></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Votes:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="votes1" size="8"> Number of votes this listing has
      received</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong> Number
      of Hits:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="hits1" size="8"> Number of hits/clicks this listing
      has received</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium
      Position:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="premium1" size="8" ><br>
      If this field has a value, then this
      listing will be considered as a premium listing. For example, if this value is set to 100 and others are set to 99, 98, etc.. then this
      listing will be listed first. Listings with higher numbers are listed above listings that has lower numbers.</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Expiry Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="subs_expire1" size="13" >
      (YYYY/MM/DD)<br>
      This link will not be a premium listing if the above date has been reached. Premium links with no expiry dates (if this field is left blank) will not expire.</td>
    </tr>

	 <tr>
    <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>
    Image:</strong></td>
    <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="file" 
    name="image1" size="45" ><br>    </td>
	  </tr>

    
    $extra_key_fields[1]
    <tr>
      <td width="971" height="26" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
    </tr>
    <tr>
      <td height="30" colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>LINK 2</strong></td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Title:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="title2" size="60" style="width:100%"><br>
      Max 255 Chars</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="description2" cols="59" style="width:100%"
      ></textarea><br>
      Max 255 Characters</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="keywords2" size="60" style="width:100%"><br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url2" size="60"  value="http://" style="width:90%">
      <input type="submit" value="Fetch" name="metainfo1" 
        onClick="popup('$admin_url/admin72.cgi?metpos=2&fct=meta1&url=' + url2.value);return false;">
      <br>
      Max 255 Characters</td>
    </tr>
    
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="name2" size="43" style="width:100%"><br>
      Max 100 Characters - The name of the
      submitter or company name</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email
      Address:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="email2" size="60" style="width:100%"><br>
      Max 255 Characters - You can use this
      email address for mailing list purposes</td>
    </tr>
$modpass2
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="urldate2" size="13" >(YYYY/MM/DD)<br>      </td>
    </tr>
    
    
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Rating:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><select name="rating2"
      size="1">
        <option value="0">Unrated</option>
        <option value="10">10</option>
        <option value="9">9</option>
        <option value="8">8</option>
        <option value="7">7</option>
        <option value="6">6</option>
        <option value="5">5</option>
        <option value="4">4</option>
        <option value="3">3</option>
        <option value="2">2</option>
        <option value="1">1</option>
      </select></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Votes:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="votes2" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Hits:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="hits2" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium
      Position:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="premium2" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Expiry Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="subs_expire2" size="13" >
      (YYYY/MM/DD)</td>
    </tr>

	 <tr>
    <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>
    Image:</strong></td>
    <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="file" 
    name="image2" size="43" ><br>    </td>
	  </tr>

    
    $extra_key_fields[2]
    <tr>
      <td width="971" height="26" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;&nbsp;&nbsp;      </td>
    </tr>
    <tr>
      <td height="30" colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>LINK 3</strong></td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Title:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="title3" size="60" style="width:100%"><br>
      Max 255 Chars</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="description3" cols="59" style="width:100%"
      ></textarea><br>
      Max 255 Characters</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="keywords3" size="60" style="width:100%"><br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url3" size="60"  value="http://" style="width:90%">
      <input type="submit" value="Fetch" name="metainfo1" 
        onClick="popup('$admin_url/admin72.cgi?metpos=3&fct=meta1&url=' + url3.value);return false;">
      <br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="name3" size="43" style="width:100%"><br>
      Max 100 Characters - The name of the
      submitter or company name</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email
      Address:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="email3" size="60" style="width:100%"><br>
      Max 255 Characters - You can use this
      email address for mailing list purposes</td>
    </tr>
$modpass3

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="urldate3" size="13" >
        (YYYY/MM/DD)<br>      </td>
    </tr>
    
    
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Rating:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><select name="rating3"
      size="1">
        <option value="0">Unrated</option>
        <option value="10">10</option>
        <option value="9">9</option>
        <option value="8">8</option>
        <option value="7">7</option>
        <option value="6">6</option>
        <option value="5">5</option>
        <option value="4">4</option>
        <option value="3">3</option>
        <option value="2">2</option>
        <option value="1">1</option>
      </select></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Votes:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="votes3" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Hits:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="hits3" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium
      Position:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="premium3" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Expiry Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="subs_expire3" size="13" >
      (YYYY/MM/DD)</td>
    </tr>
	 <tr>
    <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>
    Image:</strong></td>
    <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="file" 
    name="image3" size="43" ><br>    </td>
	  </tr>
    
    $extra_key_fields[3]
    <tr>
      <td width="971" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp;
      </strong></td>
    </tr>
    <tr>
      <td height="30" colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>LINK 4</strong></td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Title:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="title4" size="60" style="width:100%"><br>
      Max 255 Chars</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="description4" cols="59"
      style="width:100%"></textarea><br>
      Max 255 Characters</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="keywords4" size="60" style="width:100%"><br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url4" size="60"  value="http://" style="width:90%">
      <input type="submit" value="Fetch" name="metainfo1" 
        onClick="popup('$admin_url/admin72.cgi?metpos=4&fct=meta1&url=' + url4.value);return false;">
      <br>
      Max 255 Characters</td>
    </tr>


    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="name4" size="43" style="width:100%"><br>
      Max 100 Characters - The name of the
      submitter or company name</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email
      Address:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="email4" size="60" style="width:100%" ><br>
      Max 255 Characters - You can use this
      email address for mailing list purposes</td>
    </tr>
$modpass4
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="urldate4" size="20" >(YYYY/MM/DD)<br>      </td>
    </tr>
        
    
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Rating:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><select name="rating4"
      size="1">
        <option value="0">Unrated</option>
        <option value="10">10</option>
        <option value="9">9</option>
        <option value="8">8</option>
        <option value="7">7</option>
        <option value="6">6</option>
        <option value="5">5</option>
        <option value="4">4</option>
        <option value="3">3</option>
        <option value="2">2</option>
        <option value="1">1</option>
      </select></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Votes:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="votes4" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Hits:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="hits4" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium
      Position:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="premium4" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Expiry Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="subs_expire4" size="13" >
      (YYYY/MM/DD)</td>
    </tr>
	 <tr>
    <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>
    Image:</strong></td>
    <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="file" 
    name="image4" size="43" ><br>    </td>
	  </tr>
    
    $extra_key_fields[4]
    <tr>
      <td width="971" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;
      </strong></td>
    </tr>
    <tr>
      <td height="30" colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>LINK 5</strong></td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Title:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="title5" size="60" style="width:100%"><br>
      Max 255 Chars</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="description5" cols="59"
      style="width:100%"></textarea><br>
      Max 255 Characters</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="keywords5" size="60" style="width:100%"><br>
      Max 255 Characters</td>
    </tr>

    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url5" size="60"  value="http://" style="width:90%">
      <input type="submit" value="Fetch" name="metainfo1" 
        onClick="popup('$admin_url/admin72.cgi?metpos=5&fct=meta1&url=' + url5.value);return false;">
      <br>
      Max 255 Characters</td>
    </tr>


    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="name5" size="43" style="width:100%"><br>
      Max 100 Characters - The name of the
      submitter or company name</td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email
      Address:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="email5" size="60" style="width:100%"><br>
      Max 255 Characters - You can use this
      email address for mailing list purposes</td>
    </tr>
$modpass5
	<tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="urldate5" size="13" >(YYYY/MM/DD)<br>      </td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Rating:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><select name="rating5"
      size="1">
        <option value="0">Unrated</option>
        <option value="10">10</option>
        <option value="9">9</option>
        <option value="8">8</option>
        <option value="7">7</option>
        <option value="6">6</option>
        <option value="5">5</option>
        <option value="4">4</option>
        <option value="3">3</option>
        <option value="2">2</option>
        <option value="1">1</option>
      </select></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Votes:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="votes5" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Hits:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="hits5" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium
      Position:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="premium5" size="8" ></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Expiry Date:</strong></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="subs_expire5" size="13" >
      (YYYY/MM/DD)</td>
    </tr>

	 <tr>
    <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>
    Image:</strong></td>
    <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="file" 
    name="image5" size="43" ><br>    </td>
	  </tr>
    
    $extra_key_fields[5]
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</td><td width="99%"></td></tr>
</table>

  
  &nbsp; 
    </center>
  </div>
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF">
    
    <tr>
      <td align="center" valign="top" bgcolor="#FFFFFF" class="normaltext">
      <input type="checkbox" name="duplicates" value="Y"><strong>Check For Duplicates</strong><BR><BR>
      <input type="submit" value="                      Add Links                      " name="add" ><BR><BR>
        
        
        <input type="hidden" name="cid" value="$cid">
        <input type="hidden" name="ct" value="$ct">
        <input type="hidden" name="fct" value="add_listing_m_final">
        <input type="hidden" name="lv" value="$lv">
        <input type="hidden" name="rid" value="$rid">
        </td>
    </tr>
  </table>
</form>



</body>
</html>

END_OF_ADDM

}












sub fetch_meta_info
{

$url = $q->param('url');


### EXISTING DATA
$title = $q->param('title');
$description = $q->param('description');
$keywords = $q->param('keywords');
$name = $q->param('name');
$email = $q->param('email');
$password = $q->param('password');
$urldate = $q->param('urldate');

###
$rating = $q->param('rating');
$votes = $q->param('votes');
$hits = $q->param('hits');
$premium = $q->param('premium');
$subs_expire = $q->param('subs_expire');

###
$duplicates = $q->param('duplicates');

### KEYDATA
$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;
foreach $k_item (@akeys)
	{
	($k_keyname, $k_visible, $k_size, $k_searched, $k_description) = split (/\t/, $k_item);
	$keynval{$k_keyname} = $q->param($k_keyname);
	}


my $browser = LWP::UserAgent->new;
$browser->agent("Mozilla/4.0 (compatible; MSIE 5.5)"); 
my $response = $browser->get($url);
$browser->timeout(15);

if ($response->is_success)
	{
	($Htitle, $Hmetakeyw, $Hmetadiz) = &parse_html($response->content);
	&add_listing($Htitle, $Hmetadiz, $Hmetakeyw);
	}
	else
	{
	&add_listing("", "", "", $response->status_line);
	}

exit;
}




sub add_listing_final
{

$metainfo =  $q->param('metainfo');

if ($metainfo ne "") { &fetch_meta_info; exit;}

$cid = $q->param('cid');
$ct = $q->param('ct');
$lv = $q->param('lv');
$rid = $q->param('rid');

$title = $q->param('title');
$title =~ s/'/\\'/g;

$description = $q->param('description');
$description =~ s/'/\\'/g;

$keywords = $q->param('keywords');
$keywords =~ s/'/\\'/g;

$url = $q->param('url');
$url =~ s/'/\\'/g;

$name = $q->param('name');
$name =~ s/'/\\'/g;

$email = $q->param('email');
$email =~ s/'/\\'/g;

$image = $q->param('image');
$image =~ s/'/\\'/g;

$imagelinked = $q->param('imagelinked');

$rating  = $q->param('rating');
$votes   = $q->param('votes');
$hits    = $q->param('hits');
$premium = $q->param('premium');


$urldate = $q->param('urldate');
if ($urldate eq "") 
	{
	$timep = time(); 
	}
	else
	{

	$urldate =~ s/ //g;
	($pyear,$pmonth,$pday) = split (/\//, $urldate);
	$pmonth = $pmonth - 1;

	eval { $timep = timelocal(0,0,0, $pday,$pmonth,$pyear);
 		  }; #warn $@ if $@;
 	if ($@ ne "") 
 			{
 			$lnkn = $ms + 1; #<br></b>Reason:</b> $@
 			acs::problem_popup("The date ($urldate) that you specified is not a valid date. <br></b>Reason:</b> $@"); 
 			exit;
 			}
	
	}



$password = $q->param('password');
$password =~ s/'/\\'/g;


#### ERROR CHECKING
if ($title eq "") {acs::problem_popup("You have to supply a title for the listing to be added.");}

if (($q->param('ausername') ne "") and ($q->param('apassword') eq "") and ($q->param('add') eq "Add Listing & Send Email"))
	{
	acs::problem_popup("You supplied a user name for the user's control panel but you need to supply a password as well. If the account already exists enter any random password.");
	}


$premium_expiry = $q->param('subs_expire');
if ($premium_expiry ne "")
	{
	$premium_expiry =~ s/ //g;
	($pyear,$pmonth,$pday) = split (/\//, $premium_expiry);
	$pmonth = $pmonth - 1;
	
	eval { $time = timelocal(0,0,0, $pday,$pmonth,$pyear);
 		  }; #warn $@ if $@;
	 	if ($@ ne "") 
 			{
			$lnkn = $ms + 1; #<br></b>Reason:</b> $@
 			acs::problem_popup("The date ($premium_expiry) that you specified for item/link number $ms is not a valid date. <br></b>Reason:</b> $@"); 
 			}
 	
 	$premium_expiry = $time;
	}



#### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 


#### DUPLICATE CHECKING

if ($q->param('duplicates') eq "Y")
{

if (substr($url, length($url) - 1, 1) eq "/")
	{
	$url_without_slash = substr($url, length($url) - 1, 1);
	$url2 = " or A.url = '$url_without_slash'";
	}
	else
	{
	$url2 = " or A.url = '$url/'";
	}

$sql_exec = "SELECT A.title, A.description, A.url, B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16 FROM links AS A, dirs AS B WHERE (A.url = '$url' $url2) AND (B.cid = A.cid) ";
$sth = $dbh->prepare($sql_exec);
$sth->execute;
$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror";} 
$rows = $sth->rows();

while ( @row = $sth->fetchrow() )
	{
	$cats = "";
	for ($ms = 3; $ms < 20; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		}
	
		$duplicates_lnks = $duplicates_lnks . "<strong><a href=\"$row[2]\">$row[0]</a></strong><br>$row[1]<br><strong>$row[2]</strong><br><b>Category:</b> /$cats<Br><br>";
	}

	if ($duplicates_lnks ne "")
		{
		acs::problem_popup("You have indicated that you would like to check for duplicate(s). The following duplicate(s) has been found: <br><br> <font face=\"Verdana\" size=\"1\">$duplicates_lnks</font> ");
		}

}



#### GET EXTRA KEY/FIELD VALUES

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


if ($knr > 0)
	{
	foreach $k_item (@akeys)
		{
		($k_keyname, $k_visible, $k_size, $k_searched, $k_description, $k_na, $k_imagef, $k_fieldtype) = split (/\t/, $k_item);

			$realkname = $k_keyname . "_cust";
			
			if ($k_fieldtype eq "Upload")
				{
					if ($q->param($k_keyname) ne "")
						{
						(@upfile_ext) = split (/\./, $q->param($k_keyname)); $fnr1 = @upfile_ext; $efile_ext = $upfile_ext[$fnr1 -1];
						push (@extra_fields_upload, $k_keyname . ":::" . $q->param($k_keyname) . ":::" . $efile_ext);
						$extrak_values = $extrak_values . ", $realkname = '$efile_ext'";
						}
				}
				else
				{
				$keyvalue = $q->param($k_keyname);
				$keyvalue =~ s/'/\\'/g;
				$extrak_values = $extrak_values . ", $realkname = '$keyvalue'";
				}
		}
	}



#### INSERT NEW RECORD


$sth = $dbh->prepare("INSERT INTO links SET 
		cid				= '$cid',
		
		title				= '$title',
		description		= '$description',
		keywords			= '$keywords',
		url		 		= '$url',
		
		image				= '$image',
		imagelinked		= '$imagelinked',
		
		name				= '$name', 
		email				= '$email', 
		
		rating			= '$rating',
		votes				= '$votes',
		hits				= '$hits',
		premium			= '$premium',

		urldate			= '$timep',
		lnkpassword 	= '$password',
		subs_expire 	= '$premium_expiry'
		
		$extrak_values
		");


if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("SELECT lnkid FROM links WHERE lnkid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ) {$last_link_id = $row[0]; }   


#### CHECK IF IMAGE FILES DIRECTORY EXISTS

$upload_dir = "$web_dir/imagefiles";
if ((-e $upload_dir) < 1)
	{
	mkdir ($upload_dir, $default_permissions);
	chmod ($default_permissions, $upload_dir);
	}



#### DO UPLOADS OF EXTRA FIELDS

foreach $upitem (@extra_fields_upload)
	{
	($ek_extrafield_name, $ek_filename, $ek_ext) = split (/:::/, $upitem);
	
			### CREATE IMAGE DIR FOR LINK
			if ((-e "$web_dir/imagefiles/$last_link_id") < 1) 
			{
			mkdir ("$web_dir/imagefiles/$last_link_id", $default_permissions); 
			chmod ($default_permissions, "$web_dir/imagefiles/$last_link_id");
			}
	
	$upload_filehandle = $q->param($ek_extrafield_name);
	open UPLOADFILE, "> $web_dir/imagefiles/$last_link_id/$ek_extrafield_name" . "." . $ek_ext; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
	close UPLOADFILE;
	chmod($default_permissions, "$web_dir/imagefiles/$last_link_id/$ek_extrafield_name" . "." . $ek_ext);
	}



#### DO UPLOAD IF WE NEED TO UPLOAD A FILE (FOR STANDARD UPLOAD FIELD)

	
$upload_filename = $q->param('image'); 

if ($upload_filename ne "")
	{
	$upload_filename =~ s/.*[\/\\](.*)/$1/;
	
	(@fext) = split (/\./, $upload_filename);
	$fnr = @fext;
	$fextension = $fext[$fnr -1];
	
	#### GET LAST INSERTED LINK-ID FROM DB
	
	$sth = $dbh->prepare("SELECT lnkid FROM links WHERE lnkid = LAST_INSERT_ID()");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	while ( @row = $sth->fetchrow() ) {$last_insert_id = $row[0]; }  
	
	$ufname = $last_insert_id . "." . $fextension;
	$ufname = "$upload_dir/$ufname";
	
		### DO UPLOAD
		$upload_filehandle = $q->param('image');
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;
	
	### UPDATE DB TO INDICATE THAT THE LINK HAS AN IMAGE
	
	$sth = $dbh->prepare("UPDATE links SET image = '$fextension' WHERE lnkid = '$last_insert_id'");
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}	
	}


### SEND EMAIL TO INFORM LINK OWNER OF NEW LINK IF REQUIRED

if (($q->param('add') eq "Add Listing & Send Email") and ($email ne ""))
	{

	$email_message_n1 = acs::get_file_contents("$data_dir/linkincl.eml");
	@elines = split (/\n/, $email_message_n1);

	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];

	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}

	$email_message =~ s/!!title_without_link!!/$title/gi;
	$email_message =~ s/!!description!!/$description/gi;
	$email_message =~ s/!!keywords!!/$keywords/gi;
	$email_message =~ s/!!url!!/$url/gi;
	$email_message =~ s/!!name!!/$name/gi;
	$email_message =~ s/!!email!!/$email/gi;
	$email_message =~ s/!!mpassword!!/$password/gi;
	
	$expdate = acs::decode_date($timep);
	$email_message =~ s/!!date!!/$expdate/gi;
	
	$email_message =~ s/!!link_to_user_cpanel!!/$script_url\/rgs_login\.cgi/gi;


	if ($email_message =~ /!!category!!/i)
			{
				$sql = "SELECT * FROM dirs WHERE cid = '$cid'";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

				while ( @row = $sth->fetchrow() )
				{
				$cats = "";
				for ($ms = 2; $ms < 18; $ms++) 
					{
						if ($row[$ms] ne "")
						{
						$cats = $cats . $row[$ms] . " / ";
						}
					}
				}
			$cats = substr($cats, 0, length($cats) - 2);
			}
	
	$email_message =~ s/!!category!!/$cats/gi;

	$ausername = $q->param('ausername');
	$apassword = $q->param('apassword');
	if (($ausername ne "") and ($apassword ne "")) ### CHECK FOR DUPLICATE USER NAMES
		{
		
			$sql = "SELECT * FROM lnkusers WHERE rgsuser = '$ausername'";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}
			$rows = $sth->rows();
			while ( @row = $sth->fetchrow() ) {$current_user_acc_id = $row[0]; }   
			
			if ($rows < 1)
				{
				$sql = "INSERT INTO lnkusers SET 	rgsuser = '$ausername',
																rgspass = '$apassword',
																rgsname = '$name',
																rgsemail = '$email',
																activated = 'Y'";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}

				$sth = $dbh->prepare("SELECT userid FROM lnkusers WHERE userid = LAST_INSERT_ID()");
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
				while ( @row = $sth->fetchrow() ) {$last_user_id = $row[0]; }   
				
				$sql = "UPDATE links SET userid = '$last_user_id' WHERE lnkid = '$last_link_id'";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}
				}
				else
				{
				$sql = "UPDATE links SET userid = '$current_user_acc_id' WHERE lnkid = '$last_link_id'";
				$sth = $dbh->prepare($sql);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror  - From: $sql";}
				}
				
		}
	
	$email_message =~ s/!!cpanel_user!!/$ausername/gi;
	$email_message =~ s/!!cpanel_pass!!/$apassword/gi;
	
	$mdlink = "$script_url/modify.cgi?id=$last_link_id&cid=$cid";
	$email_message =~ s/!!modify_url!!/$mdlink/gi;

	acs::send_email ($from_name, $from_email, $email, $email_subject, $email_message);
	}

#########

$sth->finish;
$dbh->disconnect;

acs::update_numbers ("+", "1", $rid);

########


$hbox = acs::get_heading_box("$web_url/add.gif", "New Listing Added", qq[

<li><a href="$admin_url/admin4.cgi?fct=add_listing&amp;ct=$ct&amp;lv=$lv&amp;cid=$cid&amp;rid=$rid">Click here to add another listing</a></strong></li>
<li>Please click your browser's refresh button in the parent window (browser window from where this one was opened) to see the changes you have just made.</li>
<li><strong><a href="javascript:onClick=window.close()">Close</a> this window.</strong></li>

]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox

</body>
</html>
];


}




sub add_listing
{
my ($mtitle, $mdiz, $mkey, $cerror) = @_;

if ($cerror ne "") { $cproblem = qq[<BR><font face="Verdana" size="1">Problem fetching meta tag information:<br> <font color="#FF0000">$cerror</font></font>]; }

if ($mtitle ne "") { $title = "$mtitle"; }
if ($mdiz ne "") { $description = "$mdiz"; }
if ($mkey ne "") { $keywords = "$mkey"; }

$lv = $q->param('lv');
$cid = $q->param('cid');
$ct = $q->param('ct');
$rid = $q->param('rid');


############# GET EXTRA FIELD FILL IN BOXES

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

if ($knr > 0)
	{
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $notext, $imagek, $fieldtype) = split (/\t/, $k_item);

		
		
		if ($fieldtype eq "Upload")
			{
			$extra_key_fields = $extra_key_fields . qq[<tr><td width="29%" valign="top" bgcolor="#FFFFFF"><font color="#804040"><span class="normaltext"><strong>$description1:</strong></span></font></td>
    		<td width="72%" bgcolor="#FFFFFF"><input type="file" name="$keyname" size="45" style="width:100%"></td></tr>
  			];
			}
			else
		   {
			### IF SMALL FIELD THEN PROVIDE NORMAL FILL-IN BOX
			if ($size < 256)
				{
				
				### IF IMAGE URL FIELD
				if ($imagek eq "Yes"){$fcolor = "#008040";} else {$fcolor = "#8080C0";}
					
				$currkv = $keynval{$keyname};
				
				$extra_key_fields = $extra_key_fields . qq[
				  <tr>
			      <td width="29%" valign="top" bgcolor="#FFFFFF"><span class="normaltext"><strong> <font color="$fcolor">$description1:</font></strong></span></td>
			      <td width="72%" bgcolor="#FFFFFF"><input type="text" name="$keyname" value="$currkv" style="width:100%"></td>
				 </tr>
				];
				
				}
			### IF LARGE CHARACTER FIELD
				else
				{
				if ($imagek eq "Yes"){$fcolor = "#008040";} else {$fcolor = "#8080C0";}
				
				$currkv = $keynval{$keyname};

				$extra_key_fields = $extra_key_fields . qq[
  			    <tr>
 			    <td width="29%" valign="top" bgcolor="#FFFFFF"><strong><span class="normaltext"> <font color="$fcolor">$description1</font></strong></span></td>
 			    <td width="72%" bgcolor="#FFFFFF"><textarea rows="6" name="$keyname" cols="40" style="width:100%" value="$currkv"></textarea></td>
   			 </tr>
				];
				}
			}
		}
	}

#############

$location = acs::get_location_string ($ct);

#############

if ($url eq "") { $url = "http://"; }


$gsettings = new_gsettings acs; 

if ($gsettings->{addurl_reg_system} eq "Yes")
	{

	$user_reg_system_create_account = qq[
  <tr>
    <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>User Control Panel
    Username:</b></td>
    <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="ausername"
    size="40"> <br>
    If you are sending the owner of this link email that it has been included then you can
    automatically create an account for the user so that he/she can modify his/her link. When
    a user name and password is provided an account will automatically be created for this
    link. If you want to associate this link with an existing account use an existing user
    name where an account is already available.</td>
  </tr>
  <tr>
    <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>User Control Panel
    Password:</b></td>
    <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="apassword"
    size="40"></td>
  </tr>
    ];
	
	}
	else
	{
	$modify_password_no_user_reg = qq[
	      <tr>
	        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext">Modify Password:</td>
	        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
	    name="password" size="50" 
	    value="$password1" >
	            <br>
	          This is the password to be when a user wants to modify his/her link. <br>        </td>
      </tr>
     ];
	}




$hbox = acs::get_heading_box("$web_url/add.gif", "Add a New Listing", qq[Note that the listing title is required to be able to add a listing. The other fields are optional.]);

$helpbox = acs::quick_help("Quick Help", qq[
<li>Choose 'Add Listing & Send Email' if you would like to send email to the link owner that his/her listing has been added.</li>
<li>Type the URL in the 'URL' field and click the 'Fetch' button to fetch the link title, meta description and meta keywords.</li>
<li>The purple boxes or cells indicates extra fields that has been added to the database</li>
]);

print <<END_OF_ADD;

<html>
<head>
<title>Powerseek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }

 // End Hide -->
</script>
</head>
<body>

<form method="POST" action="$admin_url/admin4.cgi" ENCTYPE="multipart/form-data">
 
 $hbox
  
 <div align="center"><center>
 
 <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DDDDDD">
   <tr>
     <td height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF"
     class="normaltext">Add a New Listing To: <strong>$location</strong></td>
   </tr>
   <tr>
     <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Title:</strong></td>
     <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="title"
     size="60" value="$title" style="width:100%"> Max 255 Chars</td>
   </tr>
   <tr>
     <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description:</strong></td>
     <td width="75%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="4" name="description"
     cols="59" style="width:100%">$description</textarea> Max 255 Characters</td>
   </tr>
   <tr>
     <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Keywords:</strong></td>
     <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="keywords"
     size="60" value="$keywords" style="width:100%"> Max 255 Characters</td>
   </tr>
   <tr>
     <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>URL:</strong></td>
     <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="url"
     size="60" value="$url" style="width:90%"> <input type="submit" value="Fetch"
     name="metainfo"> <br>
     Max 255 Characters </td>
   </tr>
   <tr>
     <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name:</strong></td>
     <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="name"
     size="43" value="$name" style="width:100%"> Max 100 Characters - The name of the submitter
     or company name</td>
   </tr>
   <tr>
     <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Email Address:</strong></td>
     <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="email"
     size="60" value="$email" style="width:100%"> Max 255 Characters - You can use this email
     address for mailing list purposes</td>
  </tr>

$modify_password_no_user_reg
      
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Date:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
    name="urldate" size="13"  value="$urldate">
          (YYYY/MM/DD)<br>        </td>
      </tr>
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Rating:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><select name="rating"
    size="1">
            <option value="0">Unrated</option>
            <option value="10">10</option>
            <option value="9">9</option>
            <option value="8">8</option>
            <option value="7">7</option>
            <option value="6">6</option>
            <option value="5">5</option>
            <option value="4">4</option>
            <option value="3">3</option>
            <option value="2">2</option>
            <option value="1">1</option>
        </select></td>
      </tr>
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Number of Votes:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
    name="votes" size="8"  value="$votes">
            <br>
          Number of votes this listing has
          received</td>
      </tr>
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Number of Hits:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
    name="hits" size="8"  value="$hits">
            <br>
          Number of hits/clicks this listing
          has received</td>
      </tr>
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Premium Position:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
    name="premium" size="8"  value="$premium">
            <br>
          If this field has a value, then this
          listing will be considered as a premium listing. For example, if this value is set to 100
          and others are set to 99, 98, etc.. then this listing will be listed first. Listings with
          higher numbers are listed above listings that has lower numbers.</td>
      </tr>
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Premium Expiry Date:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
    name="subs_expire" size="13" 
    value="$subs_expire">
          (YYYY/MM/DD)<br>
          This link will not be a premium listing if the above date has been reached. Premium
          links with no expiry dates (if this field is left blank) will not expire.</td>
      </tr>
      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Image:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="file" name="image" size="43"
   style="width:90%" >
            <br>        </td>
      </tr>

$user_reg_system_create_account

$extra_key_fields

      <tr>
        <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>Check For Duplicates:</b></td>
        <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox"
    name="duplicates" value="Y">
          Check if the URL of this listing is already present in the index.</td>
      </tr>


<tr>
  <td width="25%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>&nbsp;&nbsp;&nbsp;&nbsp; </strong></td>
  <td width="75%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="Add Listing" name="add">
    <input type="submit" value="Add Listing & Send Email" name="add">
    <a href="$admin_url/admin75.cgi?fct=cust_inclussion_email" 
      onClick="popup('$admin_url/admin75.cgi?fct=cust_inclussion_email', 750, 600);return false;">Customize Link Inclussion Email</a>
    <input type="hidden" name="ct" value="$ct">
    <input type="hidden" name="fct" value="add_listing_final">
    <input type="hidden" name="cid" value="$cid">
    <input type="hidden" name="lv" value="$lv">
    <input type="hidden" name="rid" value="$rid"></td>
</tr>
  </table>
  </center></div>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>



<div align="center"><center>

$helpbox



</form>
</body>
</html>


END_OF_ADD
 
}




sub parse_html
{

my ($pdata) = @_;
my ($begin_title, $end_title, $title, $ms, $begin_metad, $metadata, $end_metad, $metakeyw, $metadiz);

## TITLE
if ($pdata =~ m/<title>/gi)
	{
	$begin_title = pos($pdata);
	}

if ($pdata =~ m/<\/title>/gi)
	{
	$end_title = pos($pdata);
	$end_title = $end_title - 8;
	$end_title = $end_title - $begin_title;
	}

$title = substr($pdata, $begin_title, $end_title);

$pdata =~ m//gi;

### META TAG DESC/KEYW 1

for ($ms = 0; $ms < 10; $ms++)
{

$begin_metad = 0;

if ($pdata =~ m/<meta/gi)
	{
	$begin_metad = pos($pdata);

	$metadata = substr($pdata, $begin_metad, 400);
	
	$metadata =~ s/HTTP-EQUIV/name/gi;

	if ($metadata =~ m/>/gi)
		{
		$end_metad = pos($metadata);
		$metadata = substr($metadata, 0, $end_metad -1);
		}

	$metadata =~ s/Content="//gi;
	$metadata =~ s/Content = "//gi;
	$metadata =~ s/Content= "//gi;
	$metadata =~ s/Content ="//gi;
	
	$metcq = qq["];
	$metadata =~ s/"//g;

	if (($metadata =~ /NAME=DESCRIPTION/i) or 
	   ($metadata =~ /NAME = DESCRIPTION/i) or 
	   ($metadata =~ /NAME =DESCRIPTION/i) or 
	   ($metadata =~ /NAME= DESCRIPTION/i))
		{
		$metadiz = $metadata;
		$metadiz =~ s/NAME=DESCRIPTION//gi;
		$metadiz =~ s/NAME = DESCRIPTION//gi;
		$metadiz =~ s/NAME= DESCRIPTION//gi;
		$metadiz =~ s/NAME =DESCRIPTION//gi;
		$metadiz =~ s/\n//g;
		}

	if (($metadata =~ /NAME=KEYWORDS/i) or 
	   ($metadata =~ /NAME = KEYWORDS/i) or 
	   ($metadata =~ /NAME =KEYWORDS/i) or 
	   ($metadata =~ /NAME= KEYWORDS/i))
		{
		$metakeyw = $metadata;
		$metakeyw =~ s/NAME=KEYWORDS//gi;
		$metakeyw =~ s/NAME = KEYWORDS//gi;
		$metakeyw =~ s/NAME= KEYWORDS//gi;
		$metakeyw =~ s/NAME =KEYWORDS//gi;
		$metakeyw =~ s/\n//g;
		}
	}

$pdata =~ s/<meta/<_m_e_t_a/i;

}

$crit1 = chr(10); 
$crit2 = chr(13); 

$title =~ s/$crit1//g; $title =~ s/$crit2//g;
$metakeyw =~ s/$crit1//g; $metakeyw =~ s/$crit2//g;
$metadiz =~ s/$crit1//g; $metadiz =~ s/$crit2//g;


if (substr($title, 0, 1) eq " ") { $title = substr($title, 1, length($title) - 1); }
if (substr($title, 0, 1) eq " ") { $title = substr($title, 1, length($title) - 1); }
if (substr($title, length($title) -1, 1) eq "/") { $title = substr($title, 0, length($title) - 1); }

if (substr($metakeyw, 0, 1) eq " ") { $metakeyw = substr($metakeyw, 1, length($metakeyw) - 1); }
if (substr($metakeyw, 0, 1) eq " ") { $metakeyw = substr($metakeyw, 1, length($metakeyw) - 1); }
if (substr($metakeyw, length($metakeyw) -1, 1) eq "/") { $metakeyw = substr($metakeyw, 0, length($metakeyw) - 1); }

if (substr($metadiz, 0, 1) eq " ") { $metadiz = substr($metadiz, 1, length($metadiz) - 1); }
if (substr($metadiz, 0, 1) eq " ") { $metadiz = substr($metadiz, 1, length($metadiz) - 1); }
if (substr($metadiz, length($metadiz) -1, 1) eq "/") { $metadiz = substr($metadiz, 0, length($metadiz) - 1); }

$title =~ s/\t//gi;
$metadiz =~ s/\t//gi;
$metakeyw =~ s/\t//gi;

return ($title, $metakeyw, $metadiz);

}








sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

